package org.foxarmy.barcodescannerforemployees.activities

import android.os.Bundle
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.security.crypto.EncryptedSharedPreferences
import androidx.security.crypto.MasterKeys
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.databinding.ActivityAccountSettingsBinding

class AccountSettingsActivity : AppCompatActivity() {

    private lateinit var binding: ActivityAccountSettingsBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityAccountSettingsBinding.inflate(layoutInflater)

        setContentView(binding.root)

        val masterKeyAlias = MasterKeys.getOrCreate(MasterKeys.AES256_GCM_SPEC)

        val sharedPreferences = EncryptedSharedPreferences.create(
            "sensitive",
            masterKeyAlias,
            applicationContext,
            EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
            EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
        )

        val net = Net()

        net.server = sharedPreferences.getString("server", "bsfe.foxarmy.org")!!
        net.language = sharedPreferences.getString("language", "")!!
        net.token = sharedPreferences.getString("token", "")!!

        binding.saveUsernameButton.setOnClickListener {
            val response = net.changeUsername(binding.newUsernameTextEdit.text.toString())
            Toast.makeText(this, response.body!!.string(), Toast.LENGTH_LONG).show()
        }

        binding.savePasswordButton.setOnClickListener {
            val response = net.changePassword(binding.newPasswordTextEdit.text.toString())
            Toast.makeText(this, response.body!!.string(), Toast.LENGTH_LONG).show()
        }
    }
}