package org.foxarmy.barcodescannerforemployees.activities

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.databinding.ActivityFindBarcodelessAbstractProductBinding
import org.foxarmy.barcodescannerforemployees.dataclasses.AbstractProduct
import org.foxarmy.barcodescannerforemployees.fragments.StorageFragment

class FindBarcodelessAbstractProduct() : AppCompatActivity() {
    private lateinit var binding: ActivityFindBarcodelessAbstractProductBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityFindBarcodelessAbstractProductBinding.inflate(layoutInflater)

        val ft = supportFragmentManager.beginTransaction()
        val fragment = StorageFragment.newInstance("barcodeless", arrayOf("", "             "))
        ft.replace(R.id.content, fragment)
        ft.commit()

        setContentView(binding.root)
    }

    fun selected(abstractProduct: AbstractProduct) {
        val data = Intent()
        data.putExtra("abstractProduct", abstractProduct)
        setResult(Activity.RESULT_OK, data)
        finish()
    }
}