package org.foxarmy.barcodescannerforemployees.activities

import android.app.Activity
import android.content.Intent
import android.content.SharedPreferences
import android.os.Bundle
import androidx.security.crypto.EncryptedSharedPreferences
import androidx.security.crypto.MasterKeys

class NavigatorActivity : Activity() {

    private lateinit var sharedPreferences: SharedPreferences

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        sharedPreferences = EncryptedSharedPreferences.create(
            "sensitive",
            MasterKeys.getOrCreate(MasterKeys.AES256_GCM_SPEC),
            applicationContext,
            EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
            EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
        )

        var intent = Intent(this, MainActivity::class.java)

        if (!isInGroup()) {
            intent = Intent(this, GroupActivity::class.java)
        }

        if (!isAuthenticated()) {
            intent = Intent(this, LoginActivity::class.java);
        }


        startActivity(intent);
        finish();
    }

    private fun isAuthenticated(): Boolean {
        return sharedPreferences.getString("token", "") != ""
    }

    private fun isInGroup(): Boolean {
        return sharedPreferences.getStringSet("groups", emptySet())!!.isNotEmpty()
    }
}