package org.foxarmy.barcodescannerforemployees.views

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.widget.LinearLayout
import android.widget.TextView
import androidx.core.content.ContextCompat
import org.foxarmy.barcodescannerforemployees.R
import org.foxarmy.barcodescannerforemployees.activities.ManageGroupActivity

class GroupView : LinearLayout {
    private var name: String
    private var id: Int

    constructor(activity: Activity, context: Context, name: String, id: Int) : super(context) {

        this.name = name
        this.id = id

        val inflater: LayoutInflater = activity.layoutInflater
        inflater.inflate(R.layout.group_view, this)

        findViewById<TextView>(R.id.nameTextView).text = name

        setOnClickListener {
            val intent = Intent(activity, ManageGroupActivity::class.java)
            val extras = Bundle()
            extras.putInt("groupId", id)
            intent.putExtras(extras)
            ContextCompat.startActivity(context, intent, extras)
        }
    }

}